SystemOrganization addCategory: #ConfigurationOfLEDMorph!

Object subclass: #ConfigurationOfLEDMorph
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfLEDMorph'!

!ConfigurationOfLEDMorph commentStamp: '<historical>' prior: 0!
(ConfigurationOfLEDMorph project version: '1.0') load
!

!ConfigurationOfLEDMorph class methodsFor: 'private' stamp: 'StephaneDucasse 9/8/2013 19:53'!
bootstrapPackage: aString from: aPath 
	| repository version |
	repository := MCHttpRepository
				location: aPath
				user: ''
				password: ''.
	repository
		versionReaderForFileNamed: aString , '.mcz'
		do: [:reader | 
			version := reader version.
			version load.
			version workingCopy repositoryGroup addRepository: repository]! !

!ConfigurationOfLEDMorph class methodsFor: 'catalog' stamp: 'StephaneDucasse 9/9/2013 06:59'!
catalogChangeLog

	^ '- 2013-09-12 First configuration version working in Pharo 2.0.
[[[
	(ConfigurationOfLEDMorph project version: ''1.0'') load
]]]'! !

!ConfigurationOfLEDMorph class methodsFor: 'catalog' stamp: 'StephaneDucasse 9/9/2013 06:57'!
catalogDescription

	^ 'LED defines Morph to display LED like characters and strings either in static or with lead based animation.'! !

!ConfigurationOfLEDMorph class methodsFor: 'catalog' stamp: 'StephaneDucasse 9/9/2013 07:02'!
catalogKeyClassesAndExample

	^ '==LedMorph== is a collection of LED digits that can display a decimal value.  The display can be set to flash by sending flash: true.

LedMorph can display characters:
[[[  
	LedMorph new  string:''0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ''; openInWorld
]]]

Lowercase letters will be converted to Uppercase. Characters not in the examle
above will be shown as SPACE which is char 36 in LedCharacterMorph.

[[[  
	LedMorph new  chars: 10; string:''           I must get a life''; flash: true; scrollLoop: true; openInWorld
]]]
'! !

!ConfigurationOfLEDMorph class methodsFor: 'catalog' stamp: 'StephaneDucasse 9/9/2013 06:58'!
catalogKeyWords

	^ #(UI Morph Game Letter Animation LED Display)! !

!ConfigurationOfLEDMorph class methodsFor: 'private' stamp: 'StephaneDucasse 9/8/2013 19:53'!
ensureMetacello
	"Bootstrap Gofer (if necessary), bootstrap ConfigurationOfMetacello (using old Gofer API), then load the latest 
	version of Metacello itself."

	Smalltalk at: #MetacelloProject ifAbsent: [
		Smalltalk at: #Gofer ifAbsent: [
			"Current version of Gofer from which to bootstrap - as of 1.0-beta.21"
			self bootstrapPackage: 'Gofer-Core-lr.115' from: 'http://seaside.gemstone.com/ss/metacello' ].
		Smalltalk at: #Gofer ifPresent: [:goferClass | | gofer |
			gofer := goferClass new
				url: 'http://seaside.gemstone.com/ss/metacello';
				yourself.
			[ gofer addPackage: 'ConfigurationOfMetacello' ] on: Warning do: [:ex | ex resume ].
			gofer load ].
		"load 'default' group of Metacello"
		(Smalltalk at: #ConfigurationOfMetacello) perform: #load ]! !

!ConfigurationOfLEDMorph class methodsFor: 'metacello tool support' stamp: 'StephaneDucasse 9/8/2013 19:53'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfLEDMorph class methodsFor: 'metacello tool support' stamp: 'StephaneDucasse 9/8/2013 19:53'!
lastMetacelloVersionLoad
	"Answer the last version loaded and the list of packages loaded for that version."

	LastVersionLoad == nil ifTrue: [ LastVersionLoad := nil -> 'default' ].
	^LastVersionLoad! !

!ConfigurationOfLEDMorph class methodsFor: 'loading' stamp: 'StephaneDucasse 9/8/2013 19:53'!
load
	"self load"

	^self project latestVersion load! !

!ConfigurationOfLEDMorph class methodsFor: 'loading' stamp: 'StephaneDucasse 9/8/2013 19:53'!
loadDefault
	"self loadDefault"

	^ self loadMostRecentCoreWithTests! !

!ConfigurationOfLEDMorph class methodsFor: 'loading' stamp: 'StephaneDucasse 9/8/2013 19:53'!
loadMostRecentCoreWithTests
	^self project lastVersion load: #('Core' 'Tests')! !

!ConfigurationOfLEDMorph class methodsFor: 'metacello tool support' stamp: 'StephaneDucasse 9/8/2013 19:53'!
metacelloVersion: versionString loads: anArrayOrString
	"Stash the last version loaded and the list of packages loaded for that version. The list
	 of packages will be used by the tools when doing 'Load Package Version'"

	LastVersionLoad := versionString -> anArrayOrString! !

!ConfigurationOfLEDMorph class methodsFor: 'accessing' stamp: 'StephaneDucasse 9/8/2013 19:53'!
project

	^self new project! !

!ConfigurationOfLEDMorph class methodsFor: 'unloading Metacello' stamp: 'StephaneDucasse 9/8/2013 19:53'!
unloadMetacello

	Smalltalk at: #ConfigurationOfMetacello ifPresent: [:cls | cls unloadMetacello ]! !

!ConfigurationOfLEDMorph methodsFor: 'baselines' stamp: 'StephaneDucasse 9/8/2013 19:54'!
baseline100: spec 
	<version: '1.0-baseline'>
	
	spec for: #common do: [
		spec blessing: #baseline.
		spec repository: 'http://smalltalkhub.com/mc/PharoExtras/LEDMorph/main'.	
		spec description: 'First configuration'.
		spec package: 'LED'.
			
		spec
			group: 'default' with: #('Core');
			group: 'Core' with: #('LED')
			].! !

!ConfigurationOfLEDMorph methodsFor: 'symbolic versions' stamp: 'StephaneDucasse 9/8/2013 19:53'!
development: spec
	<symbolicVersion: #'development'>

	spec for: #'common' version: '1.0'
! !

!ConfigurationOfLEDMorph methodsFor: 'accessing' stamp: 'StephaneDucasse 9/8/2013 19:53'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		self class ensureMetacello.
		"Construct Metacello project"
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self.
		project := constructor project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOfLEDMorph methodsFor: 'symbolic versions' stamp: 'StephaneDucasse 9/8/2013 19:53'!
stable: spec
	<symbolicVersion: #'stable'>

	spec for: #'common' version: '1.0'.
	! !

!ConfigurationOfLEDMorph methodsFor: 'versions' stamp: 'StephaneDucasse 9/8/2013 19:58'!
version100: spec 
	<version: '1.0' imports: #('1.0-baseline') >
	
	spec for: #common do: [
		spec blessing: #release.
		spec description: 'First Configuration'.
		
		spec package: 'LED' with: 'LED-StephaneDucasse.5'.
		]
	

! !
